/*
 * @Descripttion: 
 * @version: 
 * @Author: sueRimn
 * @Date: 2020-12-12 09:14:54
 * @LastEditors: sueRimn
 * @LastEditTime: 2020-12-20 15:34:49
 */
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import {BrowserAnimationsModule} from '@angular/platform-browser/animations';
import { MatButtonModule } from '@angular/material/button';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatIconModule } from '@angular/material/icon';
import { MatSidenavModule } from '@angular/material/sidenav';
import { NavigationModule } from './navigation/navigation.module';
import { PagesModule } from './pages/pages.module';
import { FormsModule } from '@angular/forms';
import { UiModule } from './ui/ui.module';
import { HttpClientModule } from '@angular/common/http';
import { httpInterceptorProviders } from './http-interceptors/index'
import {CacheTokenService} from './http-interceptors/cache-token.service'
import { TreeService } from'./http-interceptors/tree.service'
import { IsLoginService } from './is-login.service';
import { ComponentServiceService } from './component-service.service';
import { registerLocaleData } from '@angular/common';
import zh from '@angular/common/locales/zh';
import { ExaminerModule } from './examiner/examiner.module';
import { StudentModule} from './student/student.module'
import { NzModalModule } from 'ng-zorro-antd/modal';
registerLocaleData(zh);

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    BrowserAnimationsModule,
    MatButtonModule,
    MatCheckboxModule,
    MatSidenavModule,
    MatIconModule,
    PagesModule,
    FormsModule,
    HttpClientModule,
    ExaminerModule,
    StudentModule,
    NzModalModule
  ],
  providers: [httpInterceptorProviders, CacheTokenService,TreeService,ComponentServiceService],
  bootstrap: [AppComponent]
})
export class AppModule { }
