/*
 * @Descripttion:
 * @version:
 * @Author: sueRimn
 * @Date: 2020-12-11 16:34:26
 * @LastEditors: sueRimn
 * @LastEditTime: 2021-02-23 17:13:27
 */
import { Component, OnInit, ViewChild, Inject } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import {
  MatTreeFlatDataSource,
  MatTreeFlattener,
} from "@angular/material/tree";
import { MatPaginator } from "@angular/material/paginator";
import { FlatTreeControl } from "@angular/cdk/tree";
import { FormControl } from "@angular/forms";
import { Router, ActivatedRoute } from "@angular/router";
import { PageEvent } from "@angular/material/paginator";
import {
  MatDialogRef,
  MatDialog,
  MAT_DIALOG_DATA,
} from "@angular/material/dialog";
import { MatSnackBar, MatSnackBarConfig } from "@angular/material/snack-bar";
import { TreeService } from "../../http-interceptors/tree.service";
import { MatSort } from "@angular/material/sort";
import { MatTableDataSource } from "@angular/material/table";

@Component({
  selector: "app-examiner-new-one",
  templateUrl: "./examiner-new-one.component.html",
  styleUrls: ["./examiner-new-one.component.scss"],
})
export class ExaminerNewOneComponent implements OnInit {
  constructor(
    private http: HttpClient,
    private router: Router,
    private route: ActivatedRoute,
    private tree: TreeService,
    public dialog: MatDialog,
    public snackBar: MatSnackBar
  ) {}

  Profiles: any;
  ngOnInit(): void {
    this.Profiles = JSON.parse(sessionStorage.getItem("creatorData"));
    this.getunitdata();
    this.getOrganizations();
    this.getUnittype();
    this.getAllKeyUnit();
  }
  pattern: any = this.route.snapshot.queryParams.pattern || "";
  indexid = sessionStorage.getItem("paperId"); //上个页面传过来的id

  removeClass = document.getElementsByClassName("mat-form-field-underline");

  myControl = new FormControl();

  @ViewChild(MatSort) sort: MatSort;

  allunittype: any; //获取所有的单位类型

  //分页
  @ViewChild(MatPaginator, { static: true })
  pageEvent: PageEvent;
  paginator: MatPaginator;
  length: any; //共多少条数据
  pageSize: any; //每页条数
  pageSizeOptions: number[] = [10]; //设置每页条数
  PageNumber: any; //第几页

  displayedColumns: string[] = [
    "checked",
    "unitname",
    "jurisdictionsquadron",
    "unittype",
    "scc",
  ];
  tabledataSource: any;
  allorganizations: any;
  oldDataSource: any; //原始表格数据

  //分页事件
  chagePage(e) {
    this.PageNumber = e.pageIndex + 1;
    this.getAllKeyUnit();
  }

  submit() {
    this.PageNumber = "1";
    this.getAllKeyUnit();
  }

  //获得所有重点单位
  allKeyUnitInfo: any; //所有的重点单位
  getAllKeyUnit() {
    let paramsdata: any = {
      Name: this.companyName || "",
      OrganizationId: this.js || "",
      HasChildren: this.jscheck || "",
      USCI: this.shehui || "",
      PageNumber: this.PageNumber || "1",
      PageSize: this.pageSizeOptions[0],
    };
    this.http
      .get("/api/Companies", { params: paramsdata })
      .subscribe((data: any) => {
        this.length = data.totalCount;
        this.allKeyUnitInfo = data;
        this.tabledataSource = new MatTableDataSource(data.items);
        if (this.selectedunitArr.length != 0) {
          for (var i = 0; i < this.tabledataSource.filteredData.length; i++) {
            for (var j = 0; j < this.selectedunitArr.length; j++) {
              if (
                this.tabledataSource.filteredData[i].id ==
                this.selectedunitArr[j].id
              ) {
                this.tabledataSource.filteredData[i].checked =
                  this.selectedunitArr[j].checked;
              }
            }
          }
        }
      });
  }
  //得到当前单位信息
  getunitdata() {
    this.http.get("/api/ExamAccounts/Profiles").subscribe((data: any) => {
      this.organizationName = data.organizationName;
    });
  }
  organizationName: any; //当前单位组织机构名称
  treedata: any; //组织机构树型数据
  newArr: any = [];
  newallorganizations: any; //用于存储在原始数据基础上的每个机构增加children字段

  nodes: any = [];
  expandedKeys: any = []; //默认展开tree节点
  //得到当前单位所在组织机构的tree型数据
  getpresentOrganization() {
    this.newallorganizations = this.allorganizations;
    this.newallorganizations.forEach((item) => {
      item.children = [];
      this.newallorganizations.forEach((element) => {
        if (element.parentId == item.id) {
          item.children.push(element);
        }
      });
    });
    this.http.get("/api/ExamAccounts/Profiles").subscribe((data: any) => {
      this.organizationName = data.organizationName;
      if (this.organizationName) {
        this.newallorganizations.forEach((item) => {
          if (item.name == this.organizationName) {
            this.expandedKeys = [item.key];
            this.nodes = [item];
          }
        });
      } else {
        this.expandedKeys = this.nodes[0].key;
        this.nodes = this.tree.toTree(this.treedata);
      }
    });
  }

  //获得所有组织机构
  getOrganizations() {
    this.http
      .get("/api/Organizations", {
        params: {
          strict: "true",
        },
      })
      .subscribe((data: any) => {
        this.allorganizations = data;
        this.allorganizations.forEach((element) => {
          if (element.id === this.Profiles.organizationId) {
            element.parentId = null;
          }
        });
        this.treedata = this.tree.toTree(data);
        this.getpresentOrganization();
      });
  }

  //获得所有单位类型
  getUnittype() {
    this.http.get("/api/BuildingTypes/Simple").subscribe((data) => {
      this.allunittype = data;
    });
  }
  selectedunitArr: any = JSON.parse(sessionStorage.getItem(this.indexid)) || []; //选中单位的数组
  deleteByid = ""; //根据id取消选中
  //勾选框事件
  checkChange(e, element) {
    console.log(e, element);
    element.checked = e.checked;
    if (element.checked) {
      this.selectedunitArr.push(element);
    } else {
      for (var i = 0; i < this.selectedunitArr.length; i++) {
        if (this.selectedunitArr[i].id == element.id) {
          this.selectedunitArr.splice(i, 1);
        }
      }
    }
    console.log(this.selectedunitArr);
  }
  //删除某一个单位信息
  deleteWork(e) {
    console.log(e.target.id);
    console.log(this.tabledataSource.data);
    for (var i = 0; i < this.selectedunitArr.length; i++) {
      if (this.selectedunitArr[i].id == e.target.id) {
        this.selectedunitArr.splice(i, 1);
      }
    }
    for (var i = 0; i < this.tabledataSource.data.length; i++) {
      if (this.tabledataSource.data[i].id == e.target.id) {
        this.tabledataSource.data[i].checked = false;
      }
    }
  }
  //下一步事件
  nextClick() {
    console.log(this.pattern);
    const config = new MatSnackBarConfig();
    config.verticalPosition = "top";
    config.duration = 3000;
    if (this.selectedunitArr.length == 0) {
      this.snackBar.open("请选择单位", "确定", config);
    } else {
      if (this.pattern == "edit") {
        this.router.navigateByUrl("/examiner/create-test-score?pattern=edit");
      } else {
        sessionStorage.setItem(
          this.indexid,
          JSON.stringify(this.selectedunitArr)
        );
        this.router.navigateByUrl("/examiner/create-test-score");
      }
    }
  }
  //编辑单位信息
  editunit() {
    sessionStorage.setItem("six", "edit");
    let selectedunitArr = [];
    let selectedunitobj = [];
    this.allKeyUnitInfo.items.forEach((item) => {
      if (item.checked) {
        selectedunitArr.push(item.id);
        selectedunitobj.push(item);
      }
    });

    if (selectedunitArr.length == 0) {
      const config = new MatSnackBarConfig();
      config.verticalPosition = "top";
      config.duration = 3000;
      this.snackBar.open("请先选择要修改的单位", "确定", config);
    }
    if (selectedunitArr.length != 1 && selectedunitArr.length != 0) {
      const config = new MatSnackBarConfig();
      config.verticalPosition = "top";
      config.duration = 3000;
      this.snackBar.open("只能选择一个单位修改", "确定", config);
    }
    if (selectedunitArr.length == 1) {
      //带着id跳到修改页面
      // console.log(778,selectedunitArr[0])
      this.allKeyUnitInfo.items.forEach((item) => {
        if (item.id == selectedunitArr[0]) {
          let companyName = item.name;
          sessionStorage.setItem("companyName", companyName);
        }
      });
      sessionStorage.setItem("editable", "1");
      sessionStorage.setItem(
        selectedunitobj[0].id,
        JSON.stringify(selectedunitobj[0].companyIntegrityScore)
      );
      window.open(`/keyUnit/editplaninfo?id=${selectedunitArr[0]}`);
    }
  }

  //重置
  js: any; //辖区中队输入框
  companyName: any; //单位名称
  shehui: any; //统一社会信用代码
  unittype: any; //单位类型
  jscheck: any; //辖区中队包含下级
  OrganizationId; //
  follow: any = ""; //是否为关注单位
  integritySort: any; //完整度排序
  reset() {
    this.js = ""; //辖区中队输入框
    this.jscheck = ""; //辖区中队包含下级
    this.companyName = ""; //单位名称
    this.shehui = ""; //统一社会信用代码
    this.PageNumber = 1;
    this.pageEvent.pageIndex = 0;
    this.getAllKeyUnit();
  }

  //提交查询表单
  onSubmit(value) {
    this.PageNumber = 1;
    this.pageEvent.pageIndex = 0;
    this.getAllKeyUnit();
  }

  stopclose(e) {
    e.stopPropagation();
  }
}
