import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { examinerRoutingModule } from "./examiner-routing";
import { A11yModule } from "@angular/cdk/a11y";
import { DragDropModule } from "@angular/cdk/drag-drop";
import { PortalModule } from "@angular/cdk/portal";
import { ScrollingModule } from "@angular/cdk/scrolling";
import { CdkStepperModule } from "@angular/cdk/stepper";
import { CdkTableModule } from "@angular/cdk/table";
import { CdkTreeModule } from "@angular/cdk/tree";
import { MatAutocompleteModule } from "@angular/material/autocomplete";
import { MatBadgeModule } from "@angular/material/badge";
import { MatBottomSheetModule } from "@angular/material/bottom-sheet";
import { MatButtonModule } from "@angular/material/button";
import { MatButtonToggleModule } from "@angular/material/button-toggle";
import { MatCardModule } from "@angular/material/card";
import { MatCheckboxModule } from "@angular/material/checkbox";
import { MatChipsModule } from "@angular/material/chips";
import { MatStepperModule } from "@angular/material/stepper";
import { MatDatepickerModule } from "@angular/material/datepicker";
import { MatDialogModule } from "@angular/material/dialog";
import { MatDividerModule } from "@angular/material/divider";
import { MatExpansionModule } from "@angular/material/expansion";
import { MatGridListModule } from "@angular/material/grid-list";
import { MatIconModule } from "@angular/material/icon";
import { MatInputModule } from "@angular/material/input";
import { MatListModule } from "@angular/material/list";
import { MatMenuModule } from "@angular/material/menu";
import {
  MatNativeDateModule,
  MatRippleModule,
  MatOption,
} from "@angular/material/core";
import { MatPaginatorModule } from "@angular/material/paginator";
import { MatProgressBarModule } from "@angular/material/progress-bar";
import { MatProgressSpinnerModule } from "@angular/material/progress-spinner";
import { MatRadioModule } from "@angular/material/radio";
import { MatSelectModule } from "@angular/material/select";
import { MatSidenavModule } from "@angular/material/sidenav";
import { MatSliderModule } from "@angular/material/slider";
import { MatSlideToggleModule } from "@angular/material/slide-toggle";
import { MatSnackBarModule } from "@angular/material/snack-bar";
import { MatSortModule } from "@angular/material/sort";
import { MatTableModule } from "@angular/material/table";
import { MatTabsModule } from "@angular/material/tabs";
import { MatToolbarModule } from "@angular/material/toolbar";
import { MatTooltipModule } from "@angular/material/tooltip";
import { MatTreeModule } from "@angular/material/tree";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { MatFormFieldModule } from "@angular/material/form-field";
import { MatPaginatorIntl } from "@angular/material/paginator";
import { myPaginator } from "../ui/my-paginator";
import {
  AddPlanDialog,
  AddPlanTwoDialog,
  CreateTestScoreComponent,
  FinishDialog,
  LookTreeNodeDialog,
} from "./create-test-score/create-test-score.component";
import { NavigationModule } from "../navigation/navigation.module";
import { NzTreeModule } from "ng-zorro-antd/tree";
import { ExaminerIndexComponent } from "./examiner-index/examiner-index.component";
import { ExaminerNewOneComponent } from "./examiner-new-one/examiner-new-one.component";
import { NzDatePickerModule } from "ng-zorro-antd/date-picker";
import { PlanLevel } from "../pipes/size.pipe";
import { MarkPapersIndexComponent } from "./mark-papers-index/mark-papers-index.component";
import { MarkPapersTwoComponent } from "./mark-papers-two/mark-papers-two.component";
import { FinishDia } from "./examiner-index/examiner-index.component";
import {
  ReviewFilesComponent,
  editRightWrongComponent,
  editFractionComponent
} from "./review-files/review-files.component";
import { editorsDia } from "./create-test-score/create-test-score.component";
import { NzTreeSelectModule } from "ng-zorro-antd/tree-select";
import { EchartsComponent } from "./statistic-analysis/examStatistics/echarts/echarts.component";
import { StationExamineeComponent } from "./statistic-analysis/examStatistics/station-examinee/station-examinee.component";
import { ExamineePapersComponent } from "./statistic-analysis/examStatistics/examinee-papers/examinee-papers.component";
import { ExamineeCapacityComponent } from "./statistic-analysis/abilityAnalysis/examinee-capacity/examinee-capacity.component";
import { NzRateModule } from "ng-zorro-antd/rate";
import { EvaluateComponent } from "./review-files/evaluate/evaluate.component";
import { ReviewRecordComponent } from './mark-papers-two/review-record/review-record.component';
@NgModule({
  declarations: [
    CreateTestScoreComponent,
    AddPlanDialog,
    AddPlanTwoDialog,
    LookTreeNodeDialog,
    ExaminerIndexComponent,
    ExaminerNewOneComponent,
    FinishDialog,
    PlanLevel,
    MarkPapersIndexComponent,
    MarkPapersTwoComponent,
    FinishDia,
    ReviewFilesComponent,
    editRightWrongComponent,
    editFractionComponent,
    editorsDia,
    EchartsComponent,
    StationExamineeComponent,
    ExamineePapersComponent,
    ExamineeCapacityComponent,
    EvaluateComponent,
    ReviewRecordComponent,
  ],
  imports: [
    CommonModule,
    examinerRoutingModule,
    A11yModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    MatAutocompleteModule,
    MatBadgeModule,
    MatBottomSheetModule,
    MatButtonModule,
    MatButtonToggleModule,
    MatCardModule,
    MatCheckboxModule,
    MatChipsModule,
    MatStepperModule,
    MatDatepickerModule,
    MatDialogModule,
    MatDividerModule,
    MatExpansionModule,
    MatGridListModule,
    MatIconModule,
    MatInputModule,
    MatListModule,
    MatMenuModule,
    MatNativeDateModule,
    MatPaginatorModule,
    MatProgressBarModule,
    MatProgressSpinnerModule,
    MatRadioModule,
    MatRippleModule,
    MatSelectModule,
    MatSidenavModule,
    MatSliderModule,
    MatSlideToggleModule,
    MatSnackBarModule,
    MatSortModule,
    MatTableModule,
    MatTabsModule,
    MatToolbarModule,
    MatTooltipModule,
    MatTreeModule,
    PortalModule,
    ScrollingModule,
    ReactiveFormsModule,
    FormsModule,
    NavigationModule,
    NzTreeModule,
    NzDatePickerModule,
    NzTreeSelectModule,
    NzRateModule,
  ],
  providers: [{ provide: MatPaginatorIntl, useValue: myPaginator() }],
  exports: [PlanLevel],
  entryComponents: [FinishDia],
})
export class ExaminerModule {}
