import { HttpClient } from "@angular/common/http";
import { Component, OnInit, Inject } from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialog,
  MatDialogRef,
} from "@angular/material/dialog";
import { MatSnackBar } from "@angular/material/snack-bar";

@Component({
  selector: "app-review-record",
  templateUrl: "./review-record.component.html",
  styleUrls: ["./review-record.component.scss"],
})
export class ReviewRecordComponent implements OnInit {
  constructor(
    public http: HttpClient,
    public dialog: MatDialog,
    public snackBar: MatSnackBar,
    @Inject(MAT_DIALOG_DATA) public data: any,
    public dialogRef: MatDialogRef<any>
  ) {}

  modifyHistory = [];
  ngOnInit(): void {
    console.log(this.data);
    this.http
      .get(`/api/Examinations/${this.data.id}`)
      .subscribe((data: any) => {
        if (!data.modifyHistory) {
          return;
        }
        let modifyHistory = JSON.parse(data.modifyHistory);
        modifyHistory.forEach((element) => {
          element.data.forEach((item) => {
            item.data.forEach((i) => {
              if (i.name.indexOf("作战部署") == -1) {
                i.oldIsRight
                  ? (i.oldIsRight = "正确")
                  : (i.oldIsRight = "错误");
                i.newIsRight
                  ? (i.newIsRight = "正确")
                  : (i.newIsRight = "错误");
              }else{
                i.oldIsRight = i.oldIsRight+'分'
                i.newIsRight = i.newIsRight+'分'
              }
            });
          });
        });
        this.modifyHistory = modifyHistory.reverse();

        console.log(888, this.modifyHistory);
      });
  }
}
