import { Component, OnInit } from "@angular/core";
import { Router, NavigationExtras } from "@angular/router";
import { HttpClient, HttpHeaders } from "@angular/common/http";
declare var echarts: any;
@Component({
  selector: "app-echarts",
  templateUrl: "./echarts.component.html",
  styleUrls: ["./echarts.component.scss"],
})
export class EchartsComponent implements OnInit {
  constructor(public router: Router, private http: HttpClient) {}

  ngOnInit(): void {
    this.getProfiles();
    // window.setTimeout(() => {
    //   this.initCharts();
    // }, 0);
  }

  zhutu; //柱状图实例
  echartsData;
  zhiData = {
    name: [],
    number: [],
  };

  Profiles: any;
  getProfiles() {
    this.http.get("/api/ExamAccounts/Profiles").subscribe((data: any) => {
      this.Profiles = data;
      sessionStorage.setItem("creatorData", JSON.stringify(data));
      this.getExamStatisticalAnalyses();
    });
  }
  organizationId;
  oldOrganizationId;
  queryMode = 0;
  getExamStatisticalAnalyses() {
    let params: any = {
      QueryMode: this.queryMode,
      OrganizationId: this.organizationId
        ? this.organizationId
        : this.Profiles.organizationId,
      PageNumber: 1,
      PageSize: 9999,
    };
    this.http
      .get("/api/ExamStatisticalAnalyses/ExaminationStatistics", {
        params: params,
      })
      .subscribe((res: any) => {
        console.log(res);
        if (this.level == 1) {
          this.oldOrganizationId = params.OrganizationId;
        }
        this.echartsData = res;
        this.zhiData = {
          name: [],
          number: [],
        };
        this.echartsData.forEach((element) => {
          this.zhiData.name.push(element.organizationName);
          this.zhiData.number.push(element.count);
        });
        this.initCharts();
      });
  }

  title = "考试频次(次)";
  examinationIndex = false;
  color = "#41CDFC";
  //切换
  switch(e) {
    if (e == "频次") {
      this.title = "考试频次(次)";
      this.examinationIndex = false;
      this.color = "#41CDFC";
      this.queryMode = 0;
    } else {
      this.title = "考试人数(个)";
      this.examinationIndex = true;
      this.color = "#FF8678";
      this.queryMode = 1;
    }
    let myChart = echarts.init(document.getElementById("zhidui"));

    myChart.dispose();
    this.getProfiles();
  }
  //后退
  level = 0;
  back() {
    if (this.level == 1) {
      this.organizationId = this.Profiles.organizationId;
    } else if (this.level == 2) {
      this.organizationId = this.oldOrganizationId;
    }
    this.level = this.level - 1;
    let myChart = echarts.init(document.getElementById("zhidui"));

    myChart.dispose();
    this.getExamStatisticalAnalyses();
  }
  initCharts() {
    var detailPlanEchart = echarts.init(document.getElementById("zhidui"));
    var option = {
      title: {
        text: this.title,
        left: "5%", // 位置
        textStyle: {
          color: "#A1A1A1",
          fontSize: "16px",
          textAlign: "left",
        },
      },
      xAxis: {
        type: "category",
        data: this.zhiData.name,
        axisLabel: {
          fontSize: 12,
          lineHeight: 31,
          interval: 0,
          rotate: this.zhiData.name.length < 15 ? 0 : 40,
        },
        axisLine: {
          show: false,
        },
        splitLine: {
          show: false,
        },
        axisTick: {
          show: false,
        },
      },
      yAxis: {
        type: "value",
        axisLabel: {
          fontSize: 18,
          lineHeight: 31,
        },
        axisTick: {
          show: false,
        },
        axisLine: {
          show: false,
        },
        splitLine: {
          show: true,
          lineStyle: {
            opacity: 0.6,
            type: "dashed",
          },
        },
        show: true,
      },
      grid: {
        left: "5%",
        right: "5%",
        bottom: "1%",
        containLabel: true,
      },
      series: [
        {
          data: this.zhiData.number,
          type: "bar",
          // showBackground: true,
          backgroundStyle: {
            color: "#F2F5F6",
          },
          // barWidth: 30,
          barMaxWidth: 40,
          color: this.color,
          itemStyle: {
            normal: {
              label: {
                show: true, //开启显示
                position: "top", //在上方显示
                textStyle: {
                  //数值样式
                  color: "black",
                  fontSize: 12,
                },
              },
            },
          },

          // barWidth:"24px"
        },
      ],
    };
    detailPlanEchart.on("click", (e) => {
      this.clickFunc(e);
    });
    detailPlanEchart.setOption(option);
  }
  clickFunc(e) {
    let myChart = echarts.init(document.getElementById("zhidui"));
    console.log(e);
    this.echartsData.forEach((element) => {
      if (element.organizationName == e.name && element.level != 3) {
        this.organizationId = element.organizationId;
        this.level = this.level + 1;
        myChart.dispose();
        this.getExamStatisticalAnalyses();
      } else if (element.organizationName == e.name && element.level == 3) {
        window.open(
          "home/statistic-examination/station-examinee?organizationId=" +
            element.organizationId
        );
      }
    });
    // if (e.name.indexOf("支队") != -1) {
    //   this.zhiData = this.daData;
    //   this.level = 1;
    //   myChart.dispose();
    //   this.initCharts();
    // } else if (e.name.indexOf("大队") != -1) {
    //   this.zhiData = this.jiuData;
    //   this.level = 2;
    //   myChart.dispose();
    //   this.initCharts();
    // } else {
    //   window.open("home/statistic-examination/station-examinee");
    // }
  }
}
