import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http'

@Injectable({
  providedIn: 'root'
})

export class CacheTokenService {

  constructor(private http:HttpClient) { }
  public timer;

  //刷新token令牌定时器
  startUp = ():void=>{
    window.clearInterval(this.timer) //清一遍定时器
    this.timer = window.setInterval(()=>{
      var token = sessionStorage.getItem("token");
      var refreshToken = sessionStorage.getItem("refreshToken");
      if (token && refreshToken) {
        this.http.post('/api/ExamAccounts/RefreshToken', {
          token: token,
          refreshToken: refreshToken,
        }).subscribe((data:any) => {
          sessionStorage.setItem("realName",data.realName);
          sessionStorage.setItem("roleType",data.roleType);
          sessionStorage.setItem("token",data.token);
          sessionStorage.setItem("refreshToken",data.refreshToken);
          sessionStorage.setItem("level",data.level);
        })
      } else { this.delete() }
    },18*60*1000)
  }

  //删除定时器
  delete = ():void=> {
    window.clearInterval(this.timer)
  }

}
