/*
 * @Descripttion:
 * @version:
 * @Author: sueRimn
 * @Date: 2020-12-20 16:26:44
 * @LastEditors: sueRimn
 * @LastEditTime: 2020-12-23 10:33:24
 */
import { Component, OnInit, ViewChild, Inject, Input } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import {
  MatDialogRef,
  MatDialog,
  MAT_DIALOG_DATA,
} from "@angular/material/dialog";
import { MatPaginator } from "@angular/material/paginator";
import { MatTableDataSource } from "@angular/material/table";
import { PageEvent } from "@angular/material/paginator";
import { MatSnackBar, MatSnackBarConfig } from "@angular/material/snack-bar";
import { FormControl } from "@angular/forms";
import { Router, ActivatedRoute } from "@angular/router";
import {
  MatTreeFlatDataSource,
  MatTreeFlattener,
} from "@angular/material/tree";
import { FlatTreeControl } from "@angular/cdk/tree";
import { TreeService } from "../../http-interceptors/tree.service";

@Component({
  selector: "app-student-exam-record",
  templateUrl: "./student-exam-record.component.html",
  styleUrls: ["./student-exam-record.component.scss"],
})
export class StudentExamRecordComponent implements OnInit {
  constructor(
    private router: Router,
    private activatedRoute: ActivatedRoute,
    public http: HttpClient,
    public dialog: MatDialog,
    public snackBar: MatSnackBar,
    private tree: TreeService
  ) {}

  ngOnInit(): void {
    this.getAlltabledate();
  }

  //分页
  @ViewChild(MatPaginator, { static: true })
  pageEvent: PageEvent;
  paginator: MatPaginator;
  length: any; //共多少条数据
  pageSize: any; //每页条数
  pageSizeOptions: number[] = [10]; //设置每页条数
  PageNumber: any; //第几页
  startTime: [];
  endTime: [];
  tabledataSource; //表格数据

  //分页事件
  chagePage(e) {
    this.PageNumber = e.pageIndex + 1;
    this.getAlltabledate();
  }

  //获取表格信息
  getAlltabledate() {
    let paramsdata: any = {
      PageNumber: this.PageNumber || "1",
      PageSize: this.pageSizeOptions[0],
      Sort: null,
      SortType: null,
    };
    this.http
      .get("/api/Examinations", { params: paramsdata })
      .subscribe((data: any) => {
        this.tabledataSource = data.items;
        this.length = data.totalCount;
      });
  }

  //查看试卷
  seePaper(e) {
    window.open(`/reviewFiles?examId=${e.id}&paperType=2`);
  }
}
