/*
 * @Descripttion: 
 * @version: 
 * @Author: sueRimn
 * @Date: 2020-12-13 10:18:14
 * @LastEditors: sueRimn
 * @LastEditTime: 2020-12-14 10:29:32
 */
import { Component, OnInit,Output,EventEmitter } from '@angular/core';
import { HttpClient } from '@angular/common/http'
import { Router,ActivatedRoute } from '@angular/router'
import { MatDialog } from '@angular/material/dialog';
import {ChangepasswordComponent} from '../ui/changepassword/changepassword.component'
import {ChangeuserdataComponent} from '../ui/changeuserdata/changeuserdata.component'
import {CacheTokenService} from '../http-interceptors/cache-token.service'//引入服务
import {IsLoginService} from '../is-login.service'//引入服务
import { MatSnackBarConfig, MatSnackBar } from '@angular/material/snack-bar';



@Component({
  selector: 'app-tabbar',
  templateUrl: './tabbar.component.html',
  styleUrls: ['./tabbar.component.scss']
})
export class TabbarComponent implements OnInit {

  constructor(private http:HttpClient,private router:Router,private route:ActivatedRoute,public token:CacheTokenService,public dialog: MatDialog,public isLogin:IsLoginService,public snackBar: MatSnackBar,) { }

  ngOnInit() {
    this.realName = sessionStorage.getItem('realName')
  }

  realName:string; //登录用户角色


  //退出系统
  signOut () {
    let out = confirm("您确定要退出吗")
    if(out) {
      this.http.post('/api/ExamAccounts/SignOut',{}).subscribe(data=>{
        sessionStorage.clear()
        localStorage.clear()
        this.token.delete()
        this.router.navigate(['/login'])
        const config = new MatSnackBarConfig();
        config.verticalPosition = 'top';
        config.duration = 3000
        this.snackBar.open('退出成功','确定',config);
      })
    } //if

  }

  //修改用户资料
  changeUserData () {
    let dialogRef = this.dialog.open(ChangeuserdataComponent);
    dialogRef.afterClosed().subscribe();  
  }

  //修改密码
  changPassword() {
    let dialogRef = this.dialog.open(ChangepasswordComponent);
    dialogRef.afterClosed().subscribe();   
  }



}
