import { NgModule } from "@angular/core";
import { CommonModule } from "@angular/common";
import { UiRoutingModule } from "./ui-routing.module";
import { A11yModule } from "@angular/cdk/a11y";
import { DragDropModule } from "@angular/cdk/drag-drop";
import { PortalModule } from "@angular/cdk/portal";
import { ScrollingModule } from "@angular/cdk/scrolling";
import { CdkStepperModule } from "@angular/cdk/stepper";
import { CdkTableModule } from "@angular/cdk/table";
import { CdkTreeModule } from "@angular/cdk/tree";
import { MatAutocompleteModule } from "@angular/material/autocomplete";
import { MatBadgeModule } from "@angular/material/badge";
import { MatBottomSheetModule } from "@angular/material/bottom-sheet";
import { MatButtonModule } from "@angular/material/button";
import { MatButtonToggleModule } from "@angular/material/button-toggle";
import { MatCardModule } from "@angular/material/card";
import { MatCheckboxModule } from "@angular/material/checkbox";
import { MatChipsModule } from "@angular/material/chips";
import { MatStepperModule } from "@angular/material/stepper";
import { MatDialogModule } from "@angular/material/dialog";
import { MatDividerModule } from "@angular/material/divider";
import { MatExpansionModule } from "@angular/material/expansion";
import { MatGridListModule } from "@angular/material/grid-list";
import { MatIconModule } from "@angular/material/icon";
import { MatInputModule } from "@angular/material/input";
import { MatListModule } from "@angular/material/list";
import { MatMenuModule } from "@angular/material/menu";
import {
  MatNativeDateModule,
  MatRippleModule,
  MatOption,
} from "@angular/material/core";
import { MatPaginatorModule } from "@angular/material/paginator";
import { MatProgressBarModule } from "@angular/material/progress-bar";
import { MatProgressSpinnerModule } from "@angular/material/progress-spinner";
import { MatRadioModule } from "@angular/material/radio";
import { MatSelectModule } from "@angular/material/select";
import { MatSidenavModule } from "@angular/material/sidenav";
import { MatSliderModule } from "@angular/material/slider";
import { MatSlideToggleModule } from "@angular/material/slide-toggle";
import { MatSnackBarModule } from "@angular/material/snack-bar";
import { MatSortModule } from "@angular/material/sort";
import { MatTableModule } from "@angular/material/table";
import { MatTabsModule } from "@angular/material/tabs";
import { MatToolbarModule } from "@angular/material/toolbar";
import { MatTooltipModule } from "@angular/material/tooltip";
import { MatTreeModule } from "@angular/material/tree";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { MatFormFieldModule } from "@angular/material/form-field";
import { MatPaginatorIntl } from "@angular/material/paginator";
import { ChangepasswordComponent } from "./changepassword/changepassword.component";
import { testState } from "../pipes/size.pipe";
import { ConfirmpswDirective } from "./changepassword/equal-validator.directive";
import { FileUploadModule } from "ng2-file-upload";
import { ChangeuserdataComponent } from "./changeuserdata/changeuserdata.component";
import { IsLoginService } from "../is-login.service";
import { myPaginator } from "./my-paginator";
import { NzDatePickerModule } from "ng-zorro-antd/date-picker";
import {
  CollectionToolsComponent,
  CreateBuilding,
  EditBuilding,
  ViewDetailss,
} from "./collection-tools/collection-tools.component";
import {
  leftFunctionalDomainComponent,
  editPlaneFigureComponent,
  addDisposalNodeComponent,
  editDisposalNodeComponent,
} from "./collection-tools/leftFunctionalDomain";
import { saveOneDialog, saveTwoDialog } from "./collection-tools/save";
import { WorkingAreaComponent } from "../working-area/working-area.component";
import { NzTreeModule } from "ng-zorro-antd/tree";
import {
  examinationQuestions,
  uploadQuestions,
  uploadDisposalNodes,
} from "./collection-tools/examinationQuestions";
import { AddEnterpriserUser } from "./enterpriseuser/addenterpriseuser.component";
import {
  EnterpriseuserComponent,
  editenterpriseuser,
} from "./enterpriseuser/enterpriseuser.component";
import { AddTeacher } from "./teacherManagement/addenterpriseuser.component";
import {
  TeacherManagementComponent,
  editTeacher,
} from "./teacherManagement/enterpriseuser.component";
import { CollectionToolsExamineeComponent } from "./collection-tools-examinee/collection-tools.component";
import {
  examinationQuestionsExaminee,
  uploadDisposalNodesExaminee,
  uploadQuestionsExaminee,
} from "./collection-tools-examinee/examinationQuestions";
import {
  saveOneDialogExaminee,
  saveTwoDialogExaminee,
} from "./collection-tools-examinee/save";
import {
  CollectionToolsReadComponent,
  Score,
} from "./collection-tools-read/collection-tools.component";
import {
  examinationQuestionsRead,
  uploadDisposalNodesRead,
  uploadQuestionsRead,
} from "./collection-tools-read/examinationQuestions";
import { NzTreeSelectModule } from "ng-zorro-antd/tree-select";
import { AdministratorsComponent } from "./administrators/administrators.component";
import { AddEditAdminComponent } from "./administrators/add-edit-admin/add-edit-admin.component";
import { RemarkComponent } from './collection-tools-read/remark/remark.component';
@NgModule({
  declarations: [
    ChangepasswordComponent,
    ConfirmpswDirective,
    ChangeuserdataComponent,
    testState,
    CollectionToolsComponent,
    CreateBuilding,
    EditBuilding,
    ViewDetailss,
    leftFunctionalDomainComponent,
    editPlaneFigureComponent,
    addDisposalNodeComponent,
    editDisposalNodeComponent,
    saveOneDialog,
    saveTwoDialog,
    WorkingAreaComponent,
    examinationQuestions,
    uploadQuestions,
    AddEnterpriserUser,
    EnterpriseuserComponent,
    editenterpriseuser,
    AddTeacher,
    TeacherManagementComponent,
    editTeacher,
    uploadDisposalNodes,
    CollectionToolsExamineeComponent,
    examinationQuestionsExaminee,
    uploadQuestionsExaminee,
    uploadDisposalNodesExaminee,
    saveOneDialogExaminee,
    saveTwoDialogExaminee,
    CollectionToolsReadComponent,
    examinationQuestionsRead,
    uploadQuestionsRead,
    uploadDisposalNodesRead,
    Score,
    AdministratorsComponent,
    AddEditAdminComponent,
    RemarkComponent,
  ],
  imports: [
    NzDatePickerModule,
    CommonModule,
    UiRoutingModule,
    A11yModule,
    CdkStepperModule,
    CdkTableModule,
    CdkTreeModule,
    DragDropModule,
    MatAutocompleteModule,
    MatBadgeModule,
    MatBottomSheetModule,
    MatButtonModule,
    MatButtonToggleModule,
    MatCardModule,
    MatCheckboxModule,
    MatChipsModule,
    MatStepperModule,
    MatDialogModule,
    MatDividerModule,
    MatExpansionModule,
    MatGridListModule,
    MatIconModule,
    MatInputModule,
    MatListModule,
    MatMenuModule,
    MatNativeDateModule,
    MatPaginatorModule,
    MatProgressBarModule,
    MatProgressSpinnerModule,
    MatRadioModule,
    MatRippleModule,
    MatSelectModule,
    MatSidenavModule,
    MatSliderModule,
    MatSlideToggleModule,
    MatSnackBarModule,
    MatSortModule,
    MatTableModule,
    MatTabsModule,
    MatToolbarModule,
    MatTooltipModule,
    MatTreeModule,
    PortalModule,
    ScrollingModule,
    ReactiveFormsModule,
    FormsModule,
    FileUploadModule,
    NzTreeModule,
    NzTreeSelectModule,
  ],
  providers: [{ provide: MatPaginatorIntl, useValue: myPaginator() }],
})
export class UiModule {}
